/***************************************************************************
                  docpropertiesdlg.cpp  -  edit doc properties
                             -------------------                                         
    begin                : Sat Jan 15 2000                                           
    copyright            : (C) 2000 by Jost Schenck                         
    email                : jost@schenck.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#include <qlayout.h>
#include <qlabel.h>
#include <qlineedit.h>

#include <klocale.h>

#include "mymap_doc.h"
#include "docpropertiesdlg.h"

DocPropertiesDlg::DocPropertiesDlg(QWidget *parent, MyMapDoc* doc, const char *name ) : QTabDialog(parent,name)
{
	pDoc = doc;
	if ( pDoc )
	{
		setupPersonal();
		setupContent();
	}
	setOKButton(i18n("OK"));
	setCancelButton(i18n("Cancel"));
	connect(this, SIGNAL( applyButtonPressed() ), this, SLOT( slotOKClicked() ) );
}

DocPropertiesDlg::~DocPropertiesDlg()
{
}

void DocPropertiesDlg::setupPersonal()
{
	pPersonalTab = new QWidget( this );
	QBoxLayout* lay1 = new QVBoxLayout( pPersonalTab, 5, 5 );
  	// lay1->setAutoAdd( true );
		QBoxLayout* lay2 = new QHBoxLayout( lay1, 5 );
			QLabel* l1 = new QLabel( pPersonalTab );
			l1->setText( i18n("Author:") );
			lay2->add( l1 );
			pAuthorLine = new QLineEdit( pPersonalTab );
			pAuthorLine->setText( pDoc->authorName() );
			lay2->add( pAuthorLine );
		lay2 = new QHBoxLayout( lay1, 5 );
			l1 = new QLabel( pPersonalTab );
			l1->setText( i18n("e-Mail:") );
			lay2->add( l1 );
			pEmailLine = new QLineEdit( pPersonalTab );
			pEmailLine->setText( pDoc->authorEmail() );
			lay2->add( pEmailLine );
	addTab( pPersonalTab, i18n("Personal") );
}

void DocPropertiesDlg::setupContent()
{
}

void DocPropertiesDlg::slotOKClicked()
{
	if ( pDoc )
	{
		pDoc->setAuthorName( pAuthorLine->text() );
		pDoc->setAuthorEmail( pEmailLine->text() );
	}
}


