/***************************************************************************
                                  main.cpp
                             -------------------
    begin                : 23 Nov 99
    copyright            : (C) 1999 by Jost Schenck
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/

#include <qfile.h>

#include <kaboutdata.h>
#include <klocale.h>
#include <kcmdlineargs.h>

#include "mymap.h"
#include "mmglobal.h"

static KCmdLineOptions options[] =
{
	{ "+[file]", I18N_NOOP("A mymap file to open."), 0 },
	{ 0,0,0 }
};

int main(int argc, char *argv[])
{
	KAboutData* about = new KAboutData("mymap", I18N_NOOP("MyMap"), "0.3.0",
	                        I18N_NOOP("a mind mapping program"), 4, "(c) 1999, 2000, Jost Schenck",
	                        I18N_NOOP("MyMap is a free mind mapping program for *nix and\n"
	                                  "the KDE desktop environment.\n"
	                                  "I think, mind mapping is a trademark by Tony Buzan."),
	                        "http://familie.schenck.de/jost/mymap", "mymap-bugs@schenck.de" );
	about->addAuthor("Jost Schenck", I18N_NOOP("maintainer"), "jost@schenck.de", "http://familie.schenck.de/jost" );
	KCmdLineArgs::init( argc, argv, about );
	KCmdLineArgs::addCmdLineOptions( options );

  KApplication a;
  MyMap *mymap = new MyMap();
  KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
  if ( a.isRestored() )
  {
//  	RESTORE(mymap); // somehow doesn't work
		int n = 1;
		while (KTMainWindow::canBeRestored(n))
		{
			(new MyMap)->restore(n);
			n++;
		}
	}
	else
	{
///		MyMap * mymap = new MyMap();
		a.setMainWidget(mymap);
		mymap->show();
		
		if ( args->count() > 0 )
			mymap->openFile( QFile::decodeName( args->arg(0) ) ); // FIXME for opening more files
		else
			mymap->centerView();  // FIXME: do something like openNewDoc();
			
		args->clear();
	}

  return a.exec();
}
