/***************************************************************************
                          mmglobal.cpp  -  description                              
                             -------------------                                         
    begin                : Sun Jun 25 2000                                           
    copyright            : (C) 2000 by Jost Schenck                         
    email                : jost@schenck.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#include "mmglobal.h"

MMGlobal::MMGlobal()
{
}

MMGlobal::~MMGlobal()
{
}

QDomElement MMGlobal::createElement(const QString &tagName, const QPen &pen, QDomDocument &doc)
{
    QDomElement e=doc.createElement(tagName);
    e.setAttribute(attrPenColor, pen.color().name());
    e.setAttribute(attrPenStyle, static_cast<int>(pen.style()));
    e.setAttribute(attrWidth, pen.width());
    e.setAttribute(attrPenJoinStyle, pen.joinStyle());
    e.setAttribute(attrPenCapStyle, pen.capStyle());
    return e;
}

QPen MMGlobal::toPen(const QDomElement &element)
{
  QPen pen;
    if(element.hasAttribute(attrPenColor))
	pen.setColor(QColor(element.attribute(attrPenColor)));
    if(element.hasAttribute(attrPenStyle))
	pen.setStyle(static_cast<Qt::PenStyle>(element.attribute(attrPenStyle).toInt()));
    if(element.hasAttribute(attrWidth))
	pen.setWidth(element.attribute(attrWidth).toInt());
    if(element.hasAttribute(attrPenJoinStyle))
	pen.setJoinStyle(static_cast<Qt::PenJoinStyle>(element.attribute(attrPenJoinStyle).toInt()));
    if(element.hasAttribute(attrPenCapStyle))
	pen.setCapStyle(static_cast<Qt::PenCapStyle>(element.attribute(attrPenCapStyle).toInt()));
    return pen;
}

QDomElement MMGlobal::createElement(const QString &tagName, const QRect &rect, QDomDocument &doc)
{
    QDomElement e=doc.createElement(tagName);
    e.setAttribute(attrX, rect.left());
    e.setAttribute(attrY, rect.top());
    e.setAttribute(attrWidth, rect.width());
    e.setAttribute(attrHeight, rect.height());
    return e;
}

QRect MMGlobal::toRect(const QDomElement &element)
{
    QRect rect;
    if(element.hasAttribute(attrX))
	rect.setTop(element.attribute(attrX).toInt());
    if(element.hasAttribute(attrY))
	rect.setTop(element.attribute(attrY).toInt());
    if(element.hasAttribute(attrWidth))
	rect.setTop(element.attribute(attrWidth).toInt());
    if(element.hasAttribute(attrHeight))
	rect.setTop(element.attribute(attrHeight).toInt());
    return rect;
}

