/***************************************************************************
                         mymap.h  -  the mymap shell
                             -------------------                                         
    begin                : 23 Nov 99
    copyright            : (C) 1999 by Jost Schenck
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAP_H
#define MYMAP_H

#include <kapp.h>
#include <ktmainwindow.h>
#include <kurl.h>

// forward declarations

class MyMapDoc;
class MyMapView;
class KAction;
class KActionCollection;
class KAction;
class QPrinter;

class MyMap : public KTMainWindow
{
	Q_OBJECT
public:
	MyMap();
	~MyMap();
	KAction* action( const char* );
	KActionCollection* actionCollection();
	
public slots:
	void changeCaption();
	void openFile( const KURL& f );
	void centerView();

protected:
	virtual bool queryClose();
	virtual void saveProperties( KConfig* sc );
	virtual void readProperties( KConfig* sc );
		
private slots:
	void cut();
	void copy();
	void paste();
	void fileNew();
//	void fileQuit();
	void open();
	void save();
	void saveAs();
	void saveCopyAs();
	void print();
	void editDocProps();
	void editPrinterOptions();
			
private:
	void initNewDoc();
	void initActions();
	void initMenuBar();
	void initToolBars();
	void initStatusBar();

	MyMapDoc* pDoc;
	MyMapView* pView;
	QPrinter* printer;
	
	// Actions
	KActionCollection* pActColl;
	KAction *acFileNew, *acFileQuit, *acFileOpen,
		*acFileSave, *acFileSaveAs, *acFileSaveCopyAs,
		*acFilePrint, *acFilePrintOptions, *acFileProperties;
};

#endif
