/***************************************************************************
                         mymap_connection.h  -  description                              
                             -------------------                                         
    begin                : Sun Nov 28 1999                                           
    copyright            : (C) 1999 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/

#ifndef MYMAP_CONNECTION_H
#define MYMAP_CONNECTION_H


#include <qdom.h>
#include <qpainter.h>

#include "mymap_global.h"

class MMGlobal;

/**MyMapConnection represents the graphical connection
  *between two nodes.
  *@author Jost Schenck
  */

class MyMapConnection
{
public: 
	MyMapConnection();
	~MyMapConnection();
	
	KMMCONNECTORSTYLE style();
	int lineWidth();
	const QColor& lineColor();
	const Qt::PenStyle lineStyle();
	const QPen& linePen();
	
	void setStyle( KMMCONNECTORSTYLE );
	void setLineWidth( int );
	void setLineColor( const QColor& );
	void setLineStyle( const Qt::PenStyle );
	void setLinePen( const QPen& );

	void paint( int pX, int pY, int cX, int cY, QPainter* pPainter );
	
	QDomElement save( QDomDocument& d );
	void load( QDomElement& e );
	
private:
 	KMMCONNECTORSTYLE _style;
//	int _lineThickness;
//	QColor _lineColor;
//	Qt::PenStyle _lineStyle;
	QPen _linePen;
	MMGlobal* mmg;
};

#endif
