/***************************************************************************
               mymap_map.h  -  a map (page) in a mymap document
                             -------------------                                         
    begin                : Tue Dec 14 1999                                           
    copyright            : (C) 1999 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAP_MAP_H
#define MYMAP_MAP_H

#include <qcolor.h>
#include <qobject.h>


// forward declarations

class MyMapGraphNode;
class MyMapItem;
class MyMapDoc;
class QDomElement;
class QDomDocument;

/**A MyMapMap Object represents one map in a MyMap-Document.
  *@author Jost Schenck
  */

class MyMapMap : public QObject
{
	Q_OBJECT
public: 
	MyMapMap( MyMapDoc* );
	~MyMapMap();
	
	MyMapGraphNode* rootNode() { return pRootNode; }
	MyMapItem* itemAt( const QPoint &p );

	const QColor& bgColor() { return _bgColor; }
	void setBgColor( const QColor& b ) { _bgColor = b; emit mapPropertiesChanged(); }
	
	const QString title();
//	void setTitle( const QString );
	MyMapDoc* document() { return pDoc; }
	QDomElement save( QDomDocument& );
	void load( QDomElement& e);

signals:
	void update();
	void mapPropertiesChanged();
	
private:
	MyMapDoc* pDoc;
	MyMapGraphNode* pRootNode; // FIXME: someday allow multiple root nodes
	QColor _bgColor;
};

#endif
