/***************************************************************************
                    mymap_selection.h  -  selection object
                             -------------------                                         
    begin                : Mon Nov 29 1999                                           
    copyright            : (C) 1999 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAP_SELECTION_H
#define MYMAP_SELECTION_H

#include <qlist.h>

#include "mymap_global.h"

// forward declarations

class MyMapItem;
class QPainter;

/**MyMapSelection represents the collection of selected
  *nodes in a mindmap. Hopefully some day multi-selection.
  *@author Jost Schenck
  */

class MyMapSelection
{
public:
	MyMapSelection();
	~MyMapSelection();
		
	QCOORD x() { return xPos; }
	QCOORD y() { return yPos; }
	ResizeHandle getHandle( const QPoint& );
	
	void addObject( MyMapItem* );
	void removeObject( MyMapItem* );
	/** toggleObject returns selection status AFTER toggle */
	bool toggleObject( MyMapItem* );
	bool isSelected( MyMapItem* );
	bool isEmpty();
	bool isResizable() { return bResizable; }
	
	void clear();
	const QList<MyMapItem>& selection();
	
	void move( QCOORD x, QCOORD y );
	void resize( ResizeHandle h, const QPoint& p );
	void reparent( MyMapItem* );
	
	void paint( QPainter* );
	void setGeometry();
	
private:
	QList<MyMapItem> lSelection;
	bool bResizable;
	QCOORD xPos, yPos, w, h;
};

#endif
