/***************************************************************************
                       mymap_view.h  -  the view class
                             -------------------                                         
    begin                : Wed Nov 24 1999                                           
    copyright            : (C) 1999 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAP_VIEW_H
#define MYMAP_VIEW_H

// #include <qsplitter.h>
#include <qwidget.h>

// forward declarations

class MyMapDoc;
class MyMapCanvas;
class QScrollView;
class KActionCollection;
class QAction;
class KAction;
class KSelectAction;
class MyMapViewTabBar;

/**View class for MyMap.
  *@author Jost Schenck
  */

class MyMapView : public QWidget // QSplitter
{
	Q_OBJECT
public:
	MyMapView( MyMapDoc* doc, QWidget* parent = 0, const char* name = 0 );
	~MyMapView();
	MyMapCanvas* canvas() { return pCanvas; }
	MyMapDoc* doc() { return pDoc; }
	void setDoc( MyMapDoc* );
	int activeMapID() { return iActiveMap; }
	KAction* action( const char* name );
	KActionCollection* actionCollection();

public slots:
	void clearView();
	void appendNewChild();
	void centerView();
	void docPropertiesChanged();
	void showMap( int );
	void deleteMap( int = -1 );
	void deleteMapsDialog();
	void addMap( int, bool );
	void addMapsDialog();
	void editMapProperties();
	void cut();
	void copy();
	void paste();
	
protected:
//	virtual void resizeEvent( QResizeEvent* );
	void initActions();
private:
	MyMapDoc* pDoc;
	MyMapCanvas* pCanvas;
	int iActiveMap;
//	QWidget* pTreeView;
	QScrollView* pScrollView;
	MyMapViewTabBar* pTabBar;
	KActionCollection* pActColl;
	
	// This view's actions
	KAction* acEditCut, *acEditCopy, *acEditPaste, *acFileNew, *acFileQuit, *acFileOpen,
		*acFileSave, *acFileSaveAs, *acFilePrint;
	KAction* acNewChild, *acDeleteChild, *acEditProperties, *acSetStyleFork,
		*acSetStyleEllipse, *acSetStyleRect, *acSetStyleRoundRect;
	KAction *acDeleteSelection, *acAddMapsDialog, *acDelMapsDialog, *acEditMapProperties;
	KAction *acEditNodeProperties, *acEditConProperties;
	KSelectAction *acNodeStyle;

};

#endif
