/***************************************************************************
                mymapdlg_addmaps.cpp  -  dialog for adding maps
                             -------------------                                         
    begin                : Fri Feb 4 2000                                           
    copyright            : (C) 2000 by Jost Schenck                         
    email                : jost@schenck.de                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/

#include <qlayout.h>
#include <qlabel.h>
#include <qhbuttongroup.h>
#include <qradiobutton.h>
#include <qspinbox.h>

#include <klocale.h>

#include "mymap_map.h"
#include "mymap_canvas.h"
#include "mymap_doc.h"
#include "mymap_view.h"
#include "mymapdlg_addmaps.h"

AddMapsDlg::AddMapsDlg(QWidget *parent, const char *name )
	: KDialogBase(parent,name, true, i18n("add maps"), Ok|Cancel )
{
	debug("AddMapsDlg ctor");
	// TODO: check tutorial on developer.kde.org if I did all this correctly
	QWidget* w = new QWidget( this );
	setMainWidget( w );
	QLabel *pLabel;
	
	QVBoxLayout* vb1 = new QVBoxLayout( w );
	vb1->setMargin( marginHint() );
	vb1->setSpacing( spacingHint() );
	
	QHBoxLayout* hb1 = new QHBoxLayout( vb1 );
		pLabel = new QLabel( w );
		pLabel->setText( i18n("Insert") );
		hb1->addWidget( pLabel );
		
		pNumSpin = new QSpinBox( 1, 99, 1, w );
		pNumSpin->setValue( 1 );
		hb1->addWidget( pNumSpin );
		
		pLabel = new QLabel( w );
		pLabel->setText( i18n("maps") );
		hb1->addWidget( pLabel );
	
	pButtonGroup = new QHButtonGroup( w );
	vb1->addWidget( pButtonGroup );
		QRadioButton* rbBefore = new QRadioButton( pButtonGroup );
		rbBefore->setText( i18n("before") );
		rbAfter = new QRadioButton( pButtonGroup );
		rbAfter->setText( i18n("after") );
		pButtonGroup->setButton( 1 );
		
	QHBoxLayout* hb2 = new QHBoxLayout( vb1 );
		pLabel = new QLabel( w );
		pLabel->setText( i18n("Map Nr.") );
		hb2->addWidget( pLabel );
		
		pMapSpin = new QSpinBox( w );
		pMapSpin->setValue( 0 );
		connect( pMapSpin, SIGNAL( valueChanged(int) ), this, SLOT( setMapLabel() ) );
		hb2->addWidget( pMapSpin );
		
	pMapLabel = new QLabel( w );
	pMapLabel->setText( "map title" );
	vb1->addWidget( pMapLabel );
	
	w->setMinimumSize( w->sizeHint() );
}

AddMapsDlg::~AddMapsDlg()
{

}

void AddMapsDlg::setView( MyMapView* v )
{
	pView = v;
	if ( pView )
	{
		lMaps = pView->doc()->maps();
		debug("setView - map: %i  num: %i", pView->activeMapID(), lMaps.count() );
		pMapSpin->setRange( 0, lMaps.count() - 1 );
		pMapSpin->setValue( pView->activeMapID() );
		setMapLabel();
	}
}

void AddMapsDlg::setMapLabel()
{
	if ( pView )
	{
		// FIXME:
		pMapLabel->setText( "\"" + lMaps.at( pMapSpin->value() )->title() + "\"" );
	}
}

void AddMapsDlg::slotOk()
{
	debug("slotOk");
	if ( pView )
	{
		int i;
		for( i=0; i < pNumSpin->value(); i++ )
		{
			pView->addMap( pMapSpin->value(), ( pButtonGroup->selected()==rbBefore)?true:false );
		}
		pView->docPropertiesChanged();
		KDialogBase::slotOk();
	}
}



