/***************************************************************************
                 mymapdlg_addmaps.h  -  dialog for adding maps
                             -------------------                                         
    begin                : Fri Feb 4 2000                                           
    copyright            : (C) 2000 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAPDLG_ADDMAPS_H
#define MYMAPDLG_ADDMAPS_H

#include <qwidget.h>
#include <kdialogbase.h>

// Forward declarations

class MyMapMap;
class MyMapView;
class QSpinBox;
class QRadioButton;
class QLabel;

/**Dialog for adding maps to a mymap document.
  *@author Jost Schenck
  */

class AddMapsDlg : public KDialogBase
{
	Q_OBJECT
public: 
	AddMapsDlg(QWidget *parent=0, const char *name=0);
	~AddMapsDlg();
	void setView( MyMapView* v );

protected slots:
	void setMapLabel();
	virtual void slotOk();
	
private:
	QLabel *pMapLabel;
	QSpinBox *pNumSpin, *pMapSpin;
	QButtonGroup *pButtonGroup;
	QRadioButton *rbAfter, *rbBefore;
	MyMapView* pView;
	QList<MyMapMap> lMaps;
};

#endif
