/***************************************************************************
                         mymapview_tabbar.h  -  description
                             -------------------                                         
    begin                : Tue Jan 4 2000                                           
    copyright            : (C) 2000 by Jost Schenck                         
    email                : jost@schenck.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the ARTISTIC LICENSE.                           * 
 *                                                                         *
 ***************************************************************************/


#ifndef MYMAPVIEW_TABBAR_H
#define MYMAPVIEW_TABBAR_H

#include <qtabbar.h>

class MyMapMap;
class QPopupMenu;

/**
  *@author Jost Schenck
  */

class MyMapViewTabBar : public QTabBar
{
	Q_OBJECT
public: 
	MyMapViewTabBar(QWidget *parent=0, const char *name=0);
	~MyMapViewTabBar();
	
	void setupTabs( QList<MyMapMap>& l );
	
signals:
	void deleteMap();
	void addMap( int id, bool before = false );

public slots:
	void checkTitles();
	
protected:
	virtual void mousePressEvent( QMouseEvent* e );
	
protected slots:
	void mapMenuActivated( int id );
	void barMenuActivated( int id );
	
private:
	QPopupMenu* pOnTabMenu;
	QPopupMenu* pOnEmptyMenu;
	int clickedMapId;
};

#endif
